// fileIn("S8Web.st");
smalltalk.addClass("S8Web",smalltalk.Object, ['id', 'widgets', 'requireMap', 'requireSolver'], 'S8Web');

smalltalk.S8Web.$classVariableNames=unescape("InitialCodeContents%20CommonExpressions%20OnLoadActions")

smalltalk.init(smalltalk.S8Web);
smalltalk.S8Web.$klass.$iVarNames = ['instances'];


smalltalk.bind(smalltalk.S8Web.$klass,"install:","install_"

,function (id){var self=this;self._at(id).install();return self;}

,"startup",unescape("install%3A%20id%0D%0A%09%22%20Install%20an%20instance%20of%20the%20receiver%20in%20container.%20%22%0D%0A%0D%0A%09%28self%20@%20id%29%20install"));


smalltalk.bind(smalltalk.S8Web.$klass,"@","_at"

,function (id){var self=this;try{self.instances().do_((function(each){return ((each.id()._eq(id)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "_at", fn: function(){return each}})})();})() : nil);}));

(function(){throw({name: "stReturn", selector: "_at", fn: function(){return self.instances().add_(self.$$new().id_(id))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_at"){return $$ex.fn();} throw($$ex);}}

,unescape("accessing/instance%20creation"),unescape("@%20id%0D%0A%09%22%20Return%20the%20instance%20of%20the%20receiver%20with%20id.%0D%0A%09If%20there%20is%20no%20instance%20with%20that%20id%2C%20a%20new%20instance%20will%20be%20registered%20and%20returned.%0D%0A%09%22%0D%0A%0D%0A%09self%20instances%20do%3A%20%5B%3Aeach%7C%20each%20id%20%3D%20id%20ifTrue%3A%20%5B%20%5Eeach%20%5D.%20%5D.%0D%0A%09%5Eself%20instances%20add%3A%20%28self%20new%20id%3A%20id%29"));


smalltalk.bind(smalltalk.S8Web.$klass,"instances","instances"

,function (){var self=this;((((self['@instances'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@instances']=smalltalk.Array.$$new();})() : nil);

return self['@instances'];return self;}

,"accessing",unescape("instances%0D%0A%09%22%20Private%20-%20Return%20the%20running%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09instances%20isNil%20ifTrue%3A%20%5B%20instances%20%3A%3D%20Array%20new%20%5D.%0D%0A%09%5Einstances"));


smalltalk.bind(smalltalk.S8Web.$klass,"tool","tool"

,function (){var self=this;return ((self.instances().notEmpty()).mustBeBoolean()==true ? (function(){return self.instances().first();})() : nil);return self;}

,"accessing",unescape("tool%0D%0A%09%22%20Private%20-%20Return%20the%20first%20instance%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20instances%20notEmpty%20ifTrue%3A%20%5B%20self%20instances%20first%20%5D"));


smalltalk.bind(smalltalk.S8Web.$klass,"current","current"

,function (){var self=this;return self.tool();return self;}

,"accessing",unescape("current%0D%0A%09%22%20Private%20-%20Return%20the%20current%20instance%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20tool"));


smalltalk.bind(smalltalk.S8Web.$klass,"commonExpressions","commonExpressions"

,function (){var self=this;((((smalltalk.S8Web.classVariableAt_("CommonExpressions") || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeCommonExpressions();})() : nil);

return smalltalk.S8Web.classVariableAt_("CommonExpressions");return self;}

,"workspace",unescape("commonExpressions%0D%0A%09%22%20Private%20-%20Return%20the%20collection%20of%20frequent/common%20expressions.%20%22%0D%0A%0D%0A%09CommonExpressions%20isNil%20ifTrue%3A%20%5B%20self%20initializeCommonExpressions%20%5D.%0D%0A%09%5ECommonExpressions"));


smalltalk.bind(smalltalk.S8Web.$klass,"onLoadActions","onLoadActions"

,function (){var self=this;((((smalltalk.S8Web.classVariableAt_("OnLoadActions") || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeOnLoadActions();})() : nil);

return smalltalk.S8Web.classVariableAt_("OnLoadActions");return self;}

,"loading",unescape("onLoadActions%0D%0A%09%22%20Private%20-%20Return%20the%20collection%20of%20actions%20to%20evaluate%20when%20loaded.%20%22%0D%0A%0D%0A%09OnLoadActions%20isNil%20ifTrue%3A%20%5B%20self%20initializeOnLoadActions%20%5D.%0D%0A%09%5EOnLoadActions"));


smalltalk.bind(smalltalk.S8Web.$klass,"onLoad:","onLoad_"

,function (anAction){var self=this;try{((((anAction || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "onLoad_", fn: function(){return self.initializeOnLoadActions()}})})();})() : nil);

(function(){throw({name: "stReturn", selector: "onLoad_", fn: function(){return self.onLoadActions().add_(anAction)}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "onLoad_"){return $$ex.fn();} throw($$ex);}}

,"loading",unescape("onLoad%3A%20anAction%0D%0A%09%22%20Private%20-%20Set%20an%20action%20to%20be%20evaluated%20when%20the%20receiver%20has%20loaded.%0D%0A%09If%20anAction%20isNil%2C%20the%20known%20actions%20are%20reset.%0D%0A%09%22%0D%0A%0D%0A%09anAction%20isNil%20ifTrue%3A%20%5B%20%5Eself%20initializeOnLoadActions%20%5D.%0D%0A%09%5Eself%20onLoadActions%20add%3A%20anAction"));


smalltalk.bind(smalltalk.S8Web.$klass,"require:","require_"

,function (requirement){var self=this;return self.current().require_(requirement);return self;}

,"require",unescape("require%3A%20requirement%0D%0A%09%22%20Return%20the%20required%20object%20obtained%20from%20loading%20requirement.%20%22%0D%0A%0D%0A%09%5Eself%20current%20require%3A%20requirement"));


smalltalk.bind(smalltalk.S8Web.$klass,"addExpressions:","addExpressions_"

,function (aCollection){var self=this;smalltalk.S8Web.classVariableAt_put_("CommonExpressions",aCollection._comma(self.commonExpressions()));return self;}

,"workspace",unescape("addExpressions%3A%20aCollection%0D%0A%09%22%20Add%20a%20collection%20of%20frequent/common%20expressions%20to%20durrent%20expressions.%20%22%0D%0A%0D%0A%09CommonExpressions%20%3A%3D%20aCollection%20%2C%20self%20commonExpressions"));


smalltalk.bind(smalltalk.S8Web.$klass,"initializeCommonExpressions","initializeCommonExpressions"

,function (){var self=this;smalltalk.S8Web.classVariableAt_put_("CommonExpressions",[[unescape("%5BS8%5D--Frequent%20expressions--"), ""], ["Object withAllSubclasses...", unescape("Object%20withAllSubclasses%20collect%3A%20%5B%3Aeach%7C%20each%20name%20%5D")], ["aClass selectors", "Object selectors"], ["New class...", unescape("Object%20subclass%3A%20%23MyClass%20instanceVariableNames%3A%20%27%20%20one%20two%20%27%20category%3A%20%27MyCategory%27.")], ["FileOut aClass", "Exporter new fileOut: aClass"], ["FileOut aCategory", unescape("Exporter%20new%20fileOutCategory%3A%20%27Kernel%27.")], [unescape("System%20-%20Snapshot"), "Snapshot contents"], [unescape("System%20-%20Contents"), "Smalltalk current imageContents"], ["Scale workspace", "S8Web tool scaleWorkspaceAreas"], [unescape("%5Bupdate%20this%20list%5D"), "S8Web tool updateCommonExpressions"]]);return self;}

,"workspace",unescape("initializeCommonExpressions%0D%0A%09%22%20Private%20-%20Initialize%20the%20common%20expressions%20collection.%20%22%0D%0A%0D%0A%09CommonExpressions%20%3A%3D%20%23%28%0D%0A%09%09%23%28%20%27%5BS8%5D--Frequent%20expressions--%27%20%27%27%20%29%0D%0A%09%09%23%28%20%27Object%20withAllSubclasses...%27%20%27Object%20withAllSubclasses%20collect%3A%20%5B%3Aeach%7C%20each%20name%20%5D%27%20%29%0D%0A%09%09%23%28%20%27aClass%20selectors%27%20%27Object%20selectors%27%20%29%0D%0A%09%09%23%28%20%27New%20class...%27%20%27Object%20subclass%3A%20%23MyClass%20instanceVariableNames%3A%20%27%27%20%20one%20two%20%27%27%20category%3A%20%27%27MyCategory%27%27.%27%20%29%0D%0A%09%09%23%28%20%27FileOut%20aClass%27%20%27Exporter%20new%20fileOut%3A%20aClass%27%20%29%0D%0A%09%09%23%28%20%27FileOut%20aCategory%27%20%27Exporter%20new%20fileOutCategory%3A%20%27%27Kernel%27%27.%27%20%29%0D%0A%09%09%23%28%20%27System%20-%20Snapshot%27%20%27Snapshot%20contents%27%20%29%0D%0A%09%09%23%28%20%27System%20-%20Contents%27%20%27Smalltalk%20current%20imageContents%27%20%29%0D%0A%09%09%23%28%20%27Scale%20workspace%27%20%27S8Web%20tool%20scaleWorkspaceAreas%27%20%29%0D%0A%09%09%23%28%20%27%5Bupdate%20this%20list%5D%27%20%27S8Web%20tool%20updateCommonExpressions%27%20%29%0D%0A%09%29"));


smalltalk.bind(smalltalk.S8Web.$klass,"initializeOnLoadActions","initializeOnLoadActions"

,function (){var self=this;smalltalk.S8Web.classVariableAt_put_("OnLoadActions",smalltalk.Array.$$new());return self;}

,"initialize/release",unescape("initializeOnLoadActions%0D%0A%09%22%20Private%20-%20Initialize%20the%20onLoad%20actions%20collection.%20%22%0D%0A%0D%0A%09OnLoadActions%20%3A%3D%20Array%20new"));


smalltalk.bind(smalltalk.S8Web.$klass,"initialCodeContents","initialCodeContents"

,function (){var self=this;((((smalltalk.S8Web.classVariableAt_("InitialCodeContents") || nil) === nil)).mustBeBoolean()==true ? (function(){return self.initializeInitialCodeContents();})() : nil);

return smalltalk.S8Web.classVariableAt_("InitialCodeContents");return self;}

,"workspace",unescape("initialCodeContents%0D%0A%09%22%20Private%20-%20Initialize%20the%20initial%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09InitialCodeContents%20isNil%20ifTrue%3A%20%5B%20self%20initializeInitialCodeContents%20%5D.%0D%0A%09%5EInitialCodeContents"));


smalltalk.bind(smalltalk.S8Web.$klass,"initialCodeContents:","initialCodeContents_"

,function (aString){var self=this;smalltalk.S8Web.classVariableAt_put_("InitialCodeContents",aString);return self;}

,"workspace",unescape("initialCodeContents%3A%20aString%0D%0A%09%22%20Set%20the%20initial%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09InitialCodeContents%20%3A%3D%20aString"));


smalltalk.bind(smalltalk.S8Web.$klass,"initializeInitialCodeContents","initializeInitialCodeContents"

,function (){var self=this;self.initialCodeContents_(unescape("%0D%0A%09Object%20selectors%20sorted%0D%0A%09"));return self;}

,"workspace",unescape("initializeInitialCodeContents%0D%0A%09%22%20Private%20-%20Returns%20the%20initial%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09self%20initialCodeContents%3A%20%27%0D%0A%09Object%20selectors%20sorted%0D%0A%09%27"));


smalltalk.bind(smalltalk.S8Web,"home","home"

,function (){var self=this;return unescape("http%3A//www.aleReimondo.com");return self;}

,"accessing",unescape("home%0D%0A%09%22%20Return%20the%20home%20address.%20%22%0D%0A%0D%0A%09%5E%27http%3A//www.aleReimondo.com%27"));


smalltalk.bind(smalltalk.S8Web,"id","id"

,function (){var self=this;return self['@id'];return self;}

,"accessing",unescape("id%0D%0A%09%22%20Return%20the%20id%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eid"));


smalltalk.bind(smalltalk.S8Web,"id:","id_"

,function (aSymbol){var self=this;self['@id']=aSymbol;return self;}

,"accessing",unescape("id%3A%20aSymbol%0D%0A%09%22%20Set%20the%20id%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09id%20%3A%3D%20aSymbol"));


smalltalk.bind(smalltalk.S8Web,"useCache","useCache"

,function (){var self=this;return true;return self;}

,"private",unescape("useCache%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20use%20internal%20cache.%20%22%0D%0A%0D%0A%09%5Etrue"));


smalltalk.bind(smalltalk.S8Web,"soleInstance","soleInstance"

,function (){var self=this;return self.$klass.instances().size()._eq((1));return self;}

,"private",unescape("soleInstance%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20is%20the%20only%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20instances%20size%20%3D%201"));


smalltalk.bind(smalltalk.S8Web,"widgets","widgets"

,function (){var self=this;((((self['@widgets'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@widgets']=smalltalk.Dictionary.$$new();})() : nil);

return self['@widgets'];return self;}

,"private",unescape("widgets%0D%0A%09%22%20Private%20-%20Return%20the%20catched%20widgets%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09widgets%20isNil%20ifTrue%3A%20%5B%20widgets%20%3A%3D%20Dictionary%20new%20%5D.%0D%0A%09%5Ewidgets"));


smalltalk.bind(smalltalk.S8Web,"withChildrenOf:do:","withChildrenOf_do_"

,function (aDOMElement,aBlock){var self=this;aDOMElement.childNodesDo_((function(each){aBlock.value_(each);return self.withChildrenOf_do_(each, aBlock);}));return self;}

,"private",unescape("withChildrenOf%3A%20aDOMElement%20do%3A%20aBlock%0D%0A%09%22%20Private%20-%20Evaluate%20aBlock%20for%20children%20of%20aDOMElement%20recursivelly.%20%22%0D%0A%0D%0A%09aDOMElement%20childNodesDo%3A%20%5B%3Aeach%7C%0D%0A%09%09aBlock%20value%3A%20each.%0D%0A%09%09self%20withChildrenOf%3A%20each%20do%3A%20aBlock.%0D%0A%09%5D"));


smalltalk.bind(smalltalk.S8Web,"container","container"

,function (){var self=this;return smalltalk.DOM.document().getElementById_(self.id());return self;}

,"private",unescape("container%0D%0A%09%22%20Private%20-%20Return%20the%20DOMElement%20containing%20the%20GUI%20of%20receiver.%20%22%0D%0A%0D%0A%09%5EDOM%20document%20getElementById%3A%20self%20id"));


smalltalk.bind(smalltalk.S8Web,"widgetNamed:","widgetNamed_"

,function (aSymbol){var self=this;try{((self.soleInstance()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "widgetNamed_", fn: function(){return smalltalk.DOM.document().getElementById_(aSymbol)}})})();})() : nil);

self.withChildrenOf_do_(self.container(), (function(each){return ((aSymbol._eq(each.id())).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "widgetNamed_", fn: function(){return each}})})();})() : nil);}));

(function(){throw({name: "stReturn", selector: "widgetNamed_", fn: function(){return self.error_(unescape("Missing%20widget%20named%20%23")._comma(aSymbol))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "widgetNamed_"){return $$ex.fn();} throw($$ex);}}

,"private",unescape("widgetNamed%3A%20aSymbol%0D%0A%09%22%20Private%20-%20Return%20the%20widget%20with%20id%20aSymbol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20soleInstance%20ifTrue%3A%20%5B%20%22we%20use%20global%20lookup%20if%20possible%22%0D%0A%09%09%5EDOM%20document%20getElementById%3A%20aSymbol%0D%0A%09%5D.%0D%0A%09self%20withChildrenOf%3A%20self%20container%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09aSymbol%20%3D%20each%20id%20ifTrue%3A%20%5B%20%5Eeach%20%5D.%0D%0A%09%5D.%0D%0A%09%5Eself%20error%3A%20%27Missing%20widget%20named%20%23%27%2CaSymbol%20"));


smalltalk.bind(smalltalk.S8Web,"@","_at"

,function (aSymbol){var self=this;try{((self.useCache()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "_at", fn: function(){return self.widgetNamed_(aSymbol)}})})();})());

(function(){throw({name: "stReturn", selector: "_at", fn: function(){return self.widgets().at_ifAbsentPut_(aSymbol, (function(){return self.widgetNamed_(aSymbol);}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "_at"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("@%20aSymbol%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20element%20with%20id%20aSymbol%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20useCache%20ifFalse%3A%20%5B%20%5Eself%20widgetNamed%3A%20aSymbol%20%5D.%0D%0A%09%5Eself%20widgets%20at%3A%20aSymbol%20ifAbsentPut%3A%20%5B%20self%20widgetNamed%3A%20aSymbol%20%5D"));


smalltalk.bind(smalltalk.S8Web,"playground","playground"

,function (){var self=this;return self._at("playground");return self;}

,"private",unescape("playground%0D%0A%09%22%20Private%20-%20Return%20the%20DOMElement%20for%20playground%20embedding.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23playground"));


smalltalk.bind(smalltalk.S8Web,"showLicense","showLicense"

,function (){var self=this;(function(){return self._at("license").innerHTML_(unescape("%3Cpre%3E")._comma(smalltalk.Smalltalk.current().licenseTerms())._comma(unescape("%3C/pre%3E%0D%0A%09%3Cbr%3E%3Cb%3ENote%3A%3C/b%3E%20To%20change%20this%20text%20edit%20the%20methods%20at%20Smalltalk%23license...%0D%0A%09%3Cbr%3EPlease%20read%20the%20terms%20of%20use%20before%20saving%20this%20image.")));}).on_do_(smalltalk.Error, (function(){return self.show_(unescape("%3Ca%20href%3D%22mailTo%3AaleReimondo@smalltalking.net%22%3EWrite%20an%20email%3C/a%3E%20to%20ask%20for%20License%20terms."));}));return self;}

,"private",unescape("showLicense%0D%0A%09%22%20Private%20-%20Show%20the%20license%20terms.%20%22%0D%0A%0D%0A%09%5B%20self%20@%20%23license%20innerHTML%3A%20%27%3Cpre%3E%27%2CSmalltalk%20current%20licenseTerms%2C%27%3C/pre%3E%0D%0A%09%3Cbr%3E%3Cb%3ENote%3A%3C/b%3E%20To%20change%20this%20text%20edit%20the%20methods%20at%20Smalltalk%23license...%0D%0A%09%3Cbr%3EPlease%20read%20the%20terms%20of%20use%20before%20saving%20this%20image.%27%0D%0A%09%5D%20on%3A%20Error%20do%3A%20%5B%20self%20show%3A%20%27%3Ca%20href%3D%22mailTo%3AaleReimondo@smalltalking.net%22%3EWrite%20an%20email%3C/a%3E%20to%20ask%20for%20License%20terms.%27%20%5D."));


smalltalk.bind(smalltalk.S8Web,"install","install"

,function (){var self=this;self.container().innerHTML_(self.html());

self.open();return self;}

,"startup",unescape("install%0D%0A%09%22%20Install%20the%20receiver%20in%20element%20with%20id.%20%22%0D%0A%0D%0A%09self%20container%20innerHTML%3A%20self%20html.%0D%0A%09self%20open."));


smalltalk.bind(smalltalk.S8Web,"html","html"

,function (){var self=this;return self.workspaceHTML()._comma(self.quickViewHTML())._comma(self.transcriptHTML());return self;}

,"gui",unescape("html%0D%0A%09%22%20Return%20the%20HTML%20code%20for%20widgets%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20workspaceHTML%0D%0A%09%09%2Cself%20quickViewHTML%0D%0A%09%09%2Cself%20transcriptHTML"));


smalltalk.bind(smalltalk.S8Web,"reference","reference"

,function (){var self=this;return unescape("%28S8Web%20@%20%23")._comma(self.id().asString())._comma(unescape("%29%20"));return self;}

,"gui",unescape("reference%0D%0A%09%22%20Private%20-%20Self%20reference.%20%22%0D%0A%0D%0A%09%5E%27%28S8Web%20@%20%23%27%2Cself%20id%20asString%2C%27%29%20%27"));


smalltalk.bind(smalltalk.S8Web,"with:event:do:","with_event_do_"

,function (anID,eventName,aString){var self=this;var element=nil;element=self._at(anID).handle();

element[eventName]=self.scriptSending_(aString);return self;}

,"gui",unescape("with%3A%20anID%20event%3A%20eventName%20do%3A%20aString%0D%0A%09%22%20Private%20-%20Evaluate%20code%20in%20aString%20on%20HTML%20event%20named%20eventName%20triggered%20by%20aDOMElement.%20%22%0D%0A%0D%0A%22Do%20NOT%20work%20on%20IE%20-%20See%20https%3A//developer.mozilla.org/en/DOM/element.addEventListener%0D%0A%09self%20@%20anID%0D%0A%09%09setAttribute%3A%20eventName%0D%0A%09%09to%3A%20%28self%20codeSending%3A%20aString%29.%0D%0AWe%20use%20OLD%20mechanism%20to%20set%20handler.%0D%0A%22%09%7C%20element%20%7C%0D%0A%09element%20%3A%3D%20%28self%20@%20anID%29%20handle.%0D%0A%09element%5BeventName%5D%20%3A%3D%20%28self%20scriptSending%3A%20aString%29.%20"));


smalltalk.bind(smalltalk.S8Web,"open","open"

,function (){var self=this;self.initializeWorkspace();

self.initializeQuickView();

self.updateQuickView();

(function(aString){return self.show_(aString);}).installAs_("print");

self.onLoadActions().asActionSequence().evaluateWithArguments_(smalltalk.Array.with_(self));

self.print_(self.reference()._comma(unescape("Installed%21")));return self;}

,"gui",unescape("open%0D%0A%09%22%20Open%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20initializeWorkspace.%0D%0A%09self%20initializeQuickView.%0D%0A%09self%20updateQuickView.%0D%0A%09%5B%3AaString%7C%20self%20show%3A%20aString%20%5D%20installAs%3A%20%23print.%0D%0A%09self%20onLoadActions%20asActionSequence%20evaluateWithArguments%3A%20%28Array%20with%3A%20self%29.%0D%0A%09self%20print%3A%20self%20reference%2C%27Installed%21%27."));


smalltalk.bind(smalltalk.S8Web,"show:","show_"

,function (aString){var self=this;try{var transcript=nil;var maxSize=nil;var stream=nil;var newLine=nil;var old=nil;maxSize=((1024) * (2));

newLine=unescape("%3Cbr/%3E");

transcript=self._at("transcriptView");

((((transcript || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "show_", fn: function(){return self}})})();})() : nil);

((((aString || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "show_", fn: function(){return transcript.innerHTML_("")}})})();})() : nil);

old=transcript.innerHTML();

((((old || nil) === nil)).mustBeBoolean()==true ? (function(){return old="";})() : nil);

((old.size()._gt(maxSize)).mustBeBoolean()==true ? (function(){stream=old.copyFrom_to_((old.size()._minus(maxSize) + (1)), old.size()).stream();return old="..."._comma((function($rec){$rec.upTo_(newLine);return $rec.upTo_(smalltalk.Object.$$new());})(stream));})() : nil);

transcript.innerHTML_(old._comma(newLine)._comma(aString));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "show_"){return $$ex.fn();} throw($$ex);}}

,"transcript",unescape("show%3A%20aString%0D%0A%09%22%20Output%20aString%20on%20transcript.%20%22%0D%0A%0D%0A%09%7C%20transcript%20maxSize%20stream%20newLine%20old%20%7C%0D%0A%09maxSize%20%3A%3D%201024%20*%202.%0D%0A%09newLine%20%3A%3D%20%27%3Cbr/%3E%27.%0D%0A%09transcript%20%3A%3D%20self%20@%20%23transcriptView.%0D%0A%09transcript%20isNil%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09aString%20isNil%20ifTrue%3A%20%5B%20%5Etranscript%20innerHTML%3A%20%27%27%20%5D.%0D%0A%09old%20%3A%3D%20transcript%20innerHTML.%0D%0A%09old%20isNil%20ifTrue%3A%20%5B%20old%20%3A%3D%20%27%27%20%5D.%0D%0A%09old%20size%20%3E%20maxSize%20ifTrue%3A%20%5B%0D%0A%09%09stream%20%3A%3D%20%28old%20copyFrom%3A%20old%20size%20-%20maxSize%20+%201%20to%3A%20old%20size%29%20stream.%0D%0A%09%09old%20%3A%3D%20%27...%27%2C%28stream%20upTo%3A%20newLine%3B%20upTo%3A%20Object%20new%29.%0D%0A%09%5D.%0D%0A%09transcript%20innerHTML%3A%20old%20%2CnewLine%20%2CaString"));


smalltalk.bind(smalltalk.S8Web,"clearTranscript","clearTranscript"

,function (){var self=this;return self.show_(nil);return self;}

,"transcript",unescape("clearTranscript%0D%0A%09%22%20Clear%20the%20transcript%20view.%20%22%0D%0A%0D%0A%09%5Eself%20show%3A%20nil"));


smalltalk.bind(smalltalk.S8Web,"codeSending:to:","codeSending_to_"

,function (messageString,aReceiverString){var self=this;return unescape("%27")._comma(aReceiverString)._comma(messageString)._comma(unescape("%27"))._comma(unescape(".doIt%28%29"));return self;}

,"quickView",unescape("codeSending%3A%20messageString%20to%3A%20aReceiverString%0D%0A%09%22%20Private%20-%20Return%20the%20script%20code%20to%20route%20message%20aReceiverString.%20%22%0D%0A%0D%0A%09%5E%24%27%20%2CaReceiverString%20%2CmessageString%20%2C%24%27%20%2C%27.doIt%28%29%27"));


smalltalk.bind(smalltalk.S8Web,"codeSending:","codeSending_"

,function (messageString){var self=this;return self.codeSending_to_(messageString, self.reference());return self;}

,"quickView",unescape("codeSending%3A%20messageString%0D%0A%09%22%20Private%20-%20Return%20the%20script%20code%20to%20route%20message%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20codeSending%3A%20messageString%20to%3A%20self%20reference"));


smalltalk.bind(smalltalk.S8Web,"scriptSending:","scriptSending_"

,function (messageString){var self=this;return unescape("%5B")._comma(self.reference())._comma(messageString)._comma(unescape("%5D")).doIt();return self;}

,"quickView",unescape("scriptSending%3A%20messageString%0D%0A%09%22%20Private%20-%20Return%20the%20script%20code%20to%20route%20message%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28%27%5B%27%20%2Cself%20reference%20%2CmessageString%20%2C%27%5D%27%29%20doIt"));


smalltalk.bind(smalltalk.S8Web,"updateClassList","updateClassList"

,function (){var self=this;var list=nil;var mask=nil;var names=nil;var maxNames=nil;maxNames=(50);

list=self._at("classList");

mask=self._at("classMask").value();

names=smalltalk.Smalltalk.current().classes().collect_((function(each){return each.name();}));

((((mask || nil) !== nil)).mustBeBoolean()==true ? (function(){return names=names.select_((function(each){return each.match_(mask);}));})() : nil);

names=names.sorted();

((names.size()._gt(maxNames)).mustBeBoolean()==true ? (function(){return names=names.copyFrom_to_((1), maxNames).copyWith_(unescape("%22...more%22"));})() : nil);

list.items_([unescape("%22--class%20selector--%22")]._comma(names));return self;}

,"quickView",unescape("updateClassList%0D%0A%09%22%20Private%20-%20Update%20the%20class%20view%20widget.%20%22%0D%0A%0D%0A%09%7C%20list%20mask%20names%20maxNames%20%7C%0D%0A%09maxNames%20%3A%3D%2050.%0D%0A%09list%20%3A%3D%20self%20@%20%23classList.%0D%0A%09mask%20%3A%3D%20%28self%20@%20%23classMask%29%20value.%0D%0A%09names%20%3A%3D%20Smalltalk%20current%20classes%20collect%3A%20%5B%3Aeach%7C%20each%20name%20%5D.%0D%0A%09mask%20notNil%20ifTrue%3A%20%5B%20names%20%3A%3D%20names%20select%3A%20%5B%3Aeach%7C%20each%20match%3A%20mask%20%5D%20%5D.%0D%0A%09names%20%3A%3D%20names%20sorted.%0D%0A%09names%20size%20%3E%20maxNames%20ifTrue%3A%20%5B%20names%20%3A%3D%20%28names%20copyFrom%3A%201%20to%3A%20maxNames%29%20copyWith%3A%20%27%22...more%22%27%20%5D.%0D%0A%09list%20items%3A%20%23%28%20%27%22--class%20selector--%22%27%20%29%20%2Cnames"));


smalltalk.bind(smalltalk.S8Web,"updateMethodList","updateMethodList"

,function (){var self=this;try{var list=nil;var option=nil;var aClass=nil;var mask=nil;var addItem=nil;var addSelectors=nil;var selection=nil;var addItems=nil;var addClasses=nil;list=self._at("classList");

option=list.selectedOption();

((((option || nil) === nil).or_((function(){aClass=option.value().doIt();return ((aClass || nil) === nil);}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "updateMethodList", fn: function(){return self._at("methodList").removeAll()}})})();})() : nil);

mask=self._at("methodMask").value();

list=self._at("methodList");

list.removeAll();

addItem=(function(what){return list.addItem_(what);});

addItems=(function(tag, items){return ((items.notEmpty()).mustBeBoolean()==true ? (function(){addItem.value_(unescape("%22--")._comma(tag)._comma(unescape("--%22")));return items.do_((function(each){return addItem.value_(each);}));})() : nil);});

addClasses=(function(tag, classes){return addItems.value_value_(tag, classes.collect_((function(each){return each.name();})));});

addSelectors=(function(cls, title){selection=((((mask || nil) === nil)).mustBeBoolean()==true ? (function(){return cls.selectors();})() : (function(){return cls.selectors().select_((function(each){return each.match_(mask);}));})());return ((selection.notEmpty()).mustBeBoolean()==true ? (function(){addItem.value_(title);return selection.sorted().do_((function(selector){return addItem.value_(cls.name()._comma(unescape("%3E%3E%23"))._comma(selector));}));})() : nil);});

addItem.value_(unescape("%22")._comma(aClass.name())._comma(unescape("%22")));

addItem.value_(aClass.name()._comma(unescape("%22%20--%20fileOut%20--%20%22")));

addItems.value_value_("samples", self.expressionsFor_category_(aClass, "sample"));

addItems.value_value_("tests", self.expressionsFor_category_(aClass, "test"));

addClasses.value_value_("superclasses", aClass.allSuperclasses());

(function($rec){$rec.value_value_(aClass, unescape("%22--%20instance%20methods%20--%22"));return $rec.value_value_(aClass.$klass, unescape("%22--%20class%20methods%20--%22"));})(addSelectors);

addClasses.value_value_("subclasses", aClass.subclasses());return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "updateMethodList"){return $$ex.fn();} throw($$ex);}}

,"quickView",unescape("updateMethodList%0D%0A%09%22%20Private%20-%20Update%20the%20methods%20view%20widget.%20%22%0D%0A%0D%0A%09%7C%20list%20option%20aClass%20mask%20addItem%20addSelectors%20selection%20addItems%20addClasses%20%7C%0D%0A%09list%20%3A%3D%20self%20@%20%23classList.%0D%0A%09option%20%3A%3D%20list%20selectedOption.%0D%0A%09%28option%20isNil%20or%3A%20%5B%0D%0A%09%09aClass%20%3A%3D%20option%20value%20doIt.%20aClass%20isNil%20%5D%29%0D%0A%09%09ifTrue%3A%20%5B%20%5E%28self%20@%20%23methodList%29%20removeAll%20%5D.%0D%0A%09mask%20%3A%3D%20%28self%20@%20%23methodMask%29%20value.%0D%0A%09list%20%3A%3D%20self%20@%20%23methodList.%0D%0A%09list%20removeAll.%0D%0A%09addItem%20%3A%3D%20%5B%3Awhat%7C%20list%20addItem%3A%20what%20%5D.%0D%0A%09addItems%20%3A%3D%20%5B%3Atag%20%3Aitems%7C%0D%0A%09%09items%20notEmpty%20ifTrue%3A%20%5B%0D%0A%09%09%09addItem%20value%3A%20%27%22--%27%2Ctag%2C%27--%22%27.%0D%0A%09%09%09items%20do%3A%20%5B%3Aeach%7C%20addItem%20value%3A%20each%20%5D.%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09addClasses%20%3A%3D%20%5B%3Atag%20%3Aclasses%7C%0D%0A%09%09addItems%20value%3A%20tag%20value%3A%20%28classes%20collect%3A%20%5B%3Aeach%7C%20each%20name%20%5D%29%0D%0A%09%5D.%0D%0A%09addSelectors%20%3A%3D%20%5B%3Acls%20%3Atitle%7C%0D%0A%09%09selection%20%3A%3D%20mask%20isNil%20ifTrue%3A%20%5B%20cls%20selectors%20%5D%20ifFalse%3A%20%5B%0D%0A%09%09%09cls%20selectors%20select%3A%20%5B%3Aeach%7C%20each%20match%3A%20mask%20%5D.%0D%0A%09%09%5D.%0D%0A%09%09selection%20notEmpty%20ifTrue%3A%20%5B%0D%0A%09%09%09addItem%20value%3A%20title.%0D%0A%09%09%09selection%20sorted%20do%3A%20%5B%3Aselector%7C%0D%0A%09%09%09%09addItem%20value%3A%20cls%20name%20%2C%27%3E%3E%23%27%20%2Cselector%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09addItem%20value%3A%20%27%22%27%2CaClass%20name%2C%27%22%27.%0D%0A%09addItem%20value%3A%20aClass%20name%2C%27%22%20--%20fileOut%20--%20%22%27.%0D%0A%09addItems%20value%3A%20%23samples%20value%3A%20%28self%20expressionsFor%3A%20aClass%20category%3A%20%23sample%29.%0D%0A%09addItems%20value%3A%20%23tests%20value%3A%20%28self%20expressionsFor%3A%20aClass%20category%3A%20%23test%29.%0D%0A%09addClasses%20value%3A%20%23superclasses%20value%3A%20aClass%20allSuperclasses.%0D%0A%09addSelectors%0D%0A%09%09value%3A%20aClass%20value%3A%20%27%22--%20instance%20methods%20--%22%27%3B%0D%0A%09%09value%3A%20aClass%20class%20value%3A%20%27%22--%20class%20methods%20--%22%27.%0D%0A%09addClasses%20value%3A%20%23subclasses%20value%3A%20aClass%20subclasses."));


smalltalk.bind(smalltalk.S8Web,"expressionsFor:category:","expressionsFor_category_"

,function (aClass,category){var self=this;return aClass.$klass.selectors().select_((function(each){return each.includes_(":").not().and_((function(){return aClass.$klass._gt_gt(each).category().match_(category);}));})).collect_((function(each){return aClass.name()._comma(" ")._comma(each);}));return self;}

,"quickView",unescape("expressionsFor%3A%20aClass%20category%3A%20category%0D%0A%09%22%20Private%20-%20Return%20the%20evaluable%20expressions%20defined%20by%20aClass%20under%20category.%20%22%0D%0A%0D%0A%09%5E%28aClass%20class%20selectors%0D%0A%09%09select%3A%20%5B%3Aeach%7C%20%28each%20includes%3A%20%24%3A%29%20not%0D%0A%09%09%09and%3A%20%5B%20%28aClass%20class%20%3E%3E%20each%29%20category%20match%3A%20category%20%5D%0D%0A%09%09%5D%29%20collect%3A%20%5B%3Aeach%7C%20aClass%20name%20%2C%27%20%27%20%2Ceach%20%5D"));


smalltalk.bind(smalltalk.S8Web,"quickFileOutClassNamed:","quickFileOutClassNamed_"

,function (className){var self=this;try{var sourceCode=nil;((((className || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "quickFileOutClassNamed_", fn: function(){return self}})})();})() : nil);

sourceCode="Exporter new fileOut: "._comma(className);

(function($rec){$rec.resultValue_(sourceCode);$rec.resultValue_(sourceCode.doIt());return $rec.yourself();})(self);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "quickFileOutClassNamed_"){return $$ex.fn();} throw($$ex);}}

,"quickView",unescape("quickFileOutClassNamed%3A%20className%0D%0A%09%22%20FileOut%20smalltalk%20code%20of%20class%20named%20className.%20%22%0D%0A%0D%0A%09%7C%20sourceCode%20%7C%0D%0A%09className%20isNil%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09sourceCode%20%3A%3D%20%27Exporter%20new%20fileOut%3A%20%27%20%2CclassName.%0D%0A%09self%0D%0A%09%09resultValue%3A%20sourceCode%3B%0D%0A%09%09resultValue%3A%20sourceCode%20doIt%3B%0D%0A%09%09yourself"));


smalltalk.bind(smalltalk.S8Web,"quickFileOutMethod:","quickFileOutMethod_"

,function (spec){var self=this;try{var what=nil;((((spec || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "quickFileOutMethod_", fn: function(){return self}})})();})() : nil);

what=spec.doIt();

((((what || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "quickFileOutMethod_", fn: function(){return self}})})();})() : nil);

((what.isClass()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "quickFileOutMethod_", fn: function(){return self.quickFileOutClassNamed_(spec)}})})();})() : nil);

sourceCode=unescape("Exporter%20new%20fileOutMethod%3A%20%28")._comma(spec)._comma(unescape("%29%20of%3A%20"))._comma(spec.upTo_(unescape("%3E")));

(function($rec){$rec.value_(sourceCode);$rec.value_(sourceCode.doIt());return $rec.yourself();})(self._at("result"));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "quickFileOutMethod_"){return $$ex.fn();} throw($$ex);}}

,"quickView",unescape("quickFileOutMethod%3A%20spec%0D%0A%09%22%20FileOut%20smalltalk%20code%20of%20method%20in%20spec%20string.%20%22%0D%0A%0D%0A%09%7C%20what%20%7C%0D%0A%09spec%20isNil%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09what%20%3A%3D%20spec%20doIt.%0D%0A%09what%20isNil%20ifTrue%3A%20%5B%20%5Eself%20%5D.%0D%0A%09what%20isClass%20ifTrue%3A%20%5B%20%5Eself%20quickFileOutClassNamed%3A%20spec%20%5D.%0D%0A%09sourceCode%20%3A%3D%20%27Exporter%20new%20fileOutMethod%3A%20%28%27%20%2Cspec%20%2C%27%29%20of%3A%20%27%20%2C%28spec%20upTo%3A%20%24%3E%29.%0D%0A%09%28self%20@%20%23result%29%0D%0A%09%09value%3A%20sourceCode%3B%0D%0A%09%09value%3A%20sourceCode%20doIt%3B%0D%0A%09%09yourself"));


smalltalk.bind(smalltalk.S8Web,"classListUpdate","classListUpdate"

,function (){var self=this;var option=nil;option=self._at("classList").selectedOption();

((((option || nil) !== nil)).mustBeBoolean()==true ? (function(){return nil;})() : nil);

self.updateMethodList();return self;}

,"quickView",unescape("classListUpdate%0D%0A%09%22%20The%20classList%20has%20changed%2C%20update%20GUI%20reflecting%20change.%20%22%0D%0A%0D%0A%09%7C%20option%20%7C%0D%0A%09option%20%3A%3D%20%28self%20@%20%23classList%29%20selectedOption.%0D%0A%09option%20notNil%20ifTrue%3A%20%5B%20%22self%20quickFileOutClassNamed%3A%20option%20value%22%20%5D.%0D%0A%09self%20updateMethodList."));


smalltalk.bind(smalltalk.S8Web,"methodListUpdate","methodListUpdate"

,function (){var self=this;var option=nil;option=self._at("methodList").selectedOption();

((((option || nil) !== nil)).mustBeBoolean()==true ? (function(){return self.quickFileOutMethod_(option.value());})() : nil);return self;}

,"quickView",unescape("methodListUpdate%0D%0A%09%22%20The%20methodList%20has%20changed%2C%20update%20GUI%20reflecting%20change.%20%22%0D%0A%0D%0A%09%7C%20option%20%7C%0D%0A%09option%20%3A%3D%20%28self%20@%20%23methodList%29%20selectedOption.%0D%0A%09option%20notNil%20ifTrue%3A%20%5B%20self%20quickFileOutMethod%3A%20option%20value%20%5D."));


smalltalk.bind(smalltalk.S8Web,"updateQuickView","updateQuickView"

,function (){var self=this;(function($rec){$rec.updateClassList();$rec.updateMethodList();return $rec.yourself();})(self);return self;}

,"quickView",unescape("updateQuickView%0D%0A%09%22%20Fill%20the%20QuickView%20widgets.%20%22%0D%0A%0D%0A%09self%0D%0A%09%09updateClassList%3B%0D%0A%09%09updateMethodList%3B%0D%0A%09%09yourself"));


smalltalk.bind(smalltalk.S8Web,"initializeQuickView","initializeQuickView"

,function (){var self=this;self.with_event_do_("transcriptReset", "onclick", "clearTranscript");

self.with_event_do_("classMask", "onchange", "updateQuickView");

self.with_event_do_("classMaskChanged", "onclick", "updateQuickView");

self.with_event_do_("classList", "onchange", "classListUpdate");

self.with_event_do_("methodMask", "onchange", "updateMethodList");

self.with_event_do_("methodMaskChanged", "onclick", "updateMethodList");

self.with_event_do_("methodList", "onchange", "methodListUpdate");return self;}

,"quickView",unescape("initializeQuickView%0D%0A%09%22%20Private%20-%20Initialize%20the%20QuickView%20widgets.%20%22%0D%0A%0D%0A%09self%20with%3A%20%23transcriptReset%20event%3A%20%27onclick%27%20do%3A%20%23clearTranscript.%0D%0A%09self%20with%3A%20%23classMask%20event%3A%20%27onchange%27%20do%3A%20%23updateQuickView.%0D%0A%09self%20with%3A%20%23classMaskChanged%20event%3A%20%27onclick%27%20do%3A%20%23updateQuickView.%0D%0A%09self%20with%3A%20%23classList%20event%3A%20%27onchange%27%20do%3A%20%23classListUpdate.%0D%0A%09self%20with%3A%20%23methodMask%20event%3A%20%27onchange%27%20do%3A%20%23updateMethodList.%0D%0A%09self%20with%3A%20%23methodMaskChanged%20event%3A%20%27onclick%27%20do%3A%20%23updateMethodList.%0D%0A%09self%20with%3A%20%23methodList%20event%3A%20%27onchange%27%20do%3A%20%23methodListUpdate."));


smalltalk.bind(smalltalk.S8Web,"showIt","showIt"

,function (){var self=this;self.resultValue_(self.codeValue().doIt());return self;}

,"workspace",unescape("showIt%0D%0A%09%22%20Evaluate%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09self%20resultValue%3A%20self%20codeValue%20doIt"));


smalltalk.bind(smalltalk.S8Web,"fileItIn","fileItIn"

,function (){var self=this;self.resultValue_(self.codeValue().fileIn());return self;}

,"workspace",unescape("fileItIn%0D%0A%09%22%20FileIn%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09self%20resultValue%3A%20self%20codeValue%20fileIn"));


smalltalk.bind(smalltalk.S8Web,"evalIt","evalIt"

,function (){var self=this;self.resultValue_(eval(self.codeValue()));return self;}

,"workspace",unescape("evalIt%0D%0A%09%22%20Evaluate%20%28javascript%29%20contents%20of%20code%20pane.%20%22%0D%0A%0D%0A%09self%20resultValue%3A%20%28%23%20%23eval%3A%20self%20codeValue%29"));


smalltalk.bind(smalltalk.S8Web,"updateCommonExpressions","updateCommonExpressions"

,function (){var self=this;self._at("frequentSelector").items_(self.$klass.commonExpressions());return self;}

,"udate",unescape("updateCommonExpressions%0D%0A%09%22%20Update%20the%20common%20expressions%20list.%20%22%0D%0A%0D%0A%09self%20@%20%23frequentSelector%20items%3A%20self%20class%20commonExpressions"));


smalltalk.bind(smalltalk.S8Web,"frequentSelectorChanged","frequentSelectorChanged"

,function (){var self=this;try{var option=nil;option=self._at("frequentSelector").selectedOption();

((((option || nil) !== nil)).mustBeBoolean()==true ? (function(){option=option.value();((option.isString().and_((function(){return option.notEmpty().and_((function(){return option.first()._eq(unescape("%21"));}));}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "frequentSelectorChanged", fn: function(){return self.resultValue_(option.fileIn())}})})();})() : nil);return self.codeValue_(option);})() : nil);return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "frequentSelectorChanged"){return $$ex.fn();} throw($$ex);}}

,"workspace",unescape("frequentSelectorChanged%0D%0A%09%22%20The%20user%20selected%20an%20item%20of%20frequent%20expressions.%20%22%0D%0A%0D%0A%09%7C%20option%20%7C%0D%0A%09option%20%3A%3D%20%28self%20@%20%23frequentSelector%29%20selectedOption.%0D%0A%09option%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09option%20%3A%3D%20option%20value.%0D%0A%09%09%28option%20isString%20and%3A%20%5B%20option%20notEmpty%0D%0A%09%09%09and%3A%20%5B%20option%20first%20%3D%20%24%21%20%5D%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%5Eself%20resultValue%3A%20option%20fileIn%0D%0A%09%09%5D.%0D%0A%09%09self%20codeValue%3A%20option%0D%0A%09%5D"));


smalltalk.bind(smalltalk.S8Web,"initializeWorkspace","initializeWorkspace"

,function (){var self=this;var frequent=nil;self.with_event_do_("showIt", "onclick", "showIt");

self.with_event_do_("fileItIn", "onclick", "fileItIn");

self.with_event_do_("evalIt", "onclick", "evalIt");

self.with_event_do_("frequentSelector", "onchange", "frequentSelectorChanged");

self.updateCommonExpressions();

self.initializeNotes();

(function(){return self.scaleWorkspaceAreas();}).on_do_(smalltalk.Error, (function(){return nil;}));return self;}

,"workspace",unescape("initializeWorkspace%0D%0A%09%22%20Private%20-%20Initialize%20the%20workspace%20widgets.%20%22%0D%0A%0D%0A%09%7C%20frequent%20%7C%0D%0A%09self%20with%3A%20%23showIt%20event%3A%20%27onclick%27%20do%3A%20%23showIt.%0D%0A%09self%20with%3A%20%23fileItIn%20event%3A%20%27onclick%27%20do%3A%20%23fileItIn.%0D%0A%09self%20with%3A%20%23evalIt%20event%3A%20%27onclick%27%20do%3A%20%23evalIt.%0D%0A%0D%0A%09self%20with%3A%20%23frequentSelector%20event%3A%20%27onchange%27%20do%3A%20%23frequentSelectorChanged.%0D%0A%09self%20updateCommonExpressions.%0D%0A%09self%20initializeNotes.%0D%0A%09%5B%20self%20scaleWorkspaceAreas%20%5D%20on%3A%20Error%20do%3A%20%5B%5D."));


smalltalk.bind(smalltalk.S8Web,"initializeNotes","initializeNotes"

,function (){var self=this;self.with_event_do_("prevNote", "onclick", "prevNote");

self.with_event_do_("addNote", "onclick", "addNote");

self.with_event_do_("removeNote", "onclick", "removeNote");

self.with_event_do_("nextNote", "onclick", "nextNote");return self;}

,"notes",unescape("initializeNotes%0D%0A%09%22%20Private%20-%20Initialize%20the%20notes%20widgets.%20%22%0D%0A%0D%0A%09self%20with%3A%20%23prevNote%20event%3A%20%27onclick%27%20do%3A%20%23prevNote.%0D%0A%09self%20with%3A%20%23addNote%20event%3A%20%27onclick%27%20do%3A%20%23addNote.%0D%0A%09self%20with%3A%20%23removeNote%20event%3A%20%27onclick%27%20do%3A%20%23removeNote.%0D%0A%09self%20with%3A%20%23nextNote%20event%3A%20%27onclick%27%20do%3A%20%23nextNote."));


smalltalk.bind(smalltalk.S8Web,"scaleWorkspaceAreas","scaleWorkspaceAreas"

,function (){var self=this;var width=nil;width=smalltalk.DOM.window().innerWidth();

((((width || nil) === nil)).mustBeBoolean()==true ? (function(){return width=smalltalk.DOM.document().body().offsetWidth();})() : nil);

((((width || nil) === nil)).mustBeBoolean()==true ? (function(){return width=smalltalk.DOM.screen().width();})() : nil);

self.scaleWidthsOf_to_(smalltalk.Array.with_with_(self._at("code"), self._at("result")), (width - (80))._slash_slash(((self.portrait()).mustBeBoolean()==true ? (function(){return (1);})() : (function(){return (2);})())));return self;}

,"workspace",unescape("scaleWorkspaceAreas%0D%0A%09%22%20Scale%20the%20code%20areas%20of%20worspace%20to%20window.%20%22%0D%0A%0D%0A%09%7C%20width%20%7C%0D%0A%09width%20%3A%3D%20DOM%20window%20innerWidth.%0D%0A%09width%20isNil%20ifTrue%3A%20%5B%20width%20%3A%3D%20DOM%20document%20body%20offsetWidth%20%5D.%0D%0A%09width%20isNil%20ifTrue%3A%20%5B%20width%20%3A%3D%20DOM%20screen%20width%20%5D.%0D%0A%09self%0D%0A%09%09scaleWidthsOf%3A%20%28Array%20with%3A%20self%20@%20%23code%20with%3A%20self%20@%20%23result%29%0D%0A%09%09to%3A%20width%20-%2080%20//%20%28self%20portrait%20ifTrue%3A%20%5B1%5D%20ifFalse%3A%20%5B2%5D%29"));


smalltalk.bind(smalltalk.S8Web,"scaleWidthsOf:to:","scaleWidthsOf_to_"

,function (textAreas,width){var self=this;var colSize=nil;textAreas.do_((function(each){((each.cols()._eq((0))).mustBeBoolean()==true ? (function(){return each.cols_((1));})() : nil);colSize=each.clientWidth()._slash_slash(each.cols()).max_((1));return each.cols_(width._slash_slash(colSize));}));return self;}

,"private",unescape("scaleWidthsOf%3A%20textAreas%20to%3A%20width%0D%0A%09%22%20Private%20-%20Change%20the%20widths%20of%20textArea%20elements%20to%20width%20%28in%20pixels%29.%20%22%0D%0A%0D%0A%09%7C%20colSize%20%7C%0D%0A%09textAreas%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20cols%20%3D%200%20ifTrue%3A%20%5B%20each%20cols%3A%201%20%5D.%0D%0A%09%09colSize%20%3A%3D%20each%20clientWidth%20//%20each%20cols%20max%3A%201.%0D%0A%09%09each%20cols%3A%20width%20//%20colSize.%09%09%0D%0A%09%5D"));


smalltalk.bind(smalltalk.S8Web,"quickViewHTML","quickViewHTML"

,function (){var self=this;return unescape("%0D%0A%3Cform%20name%3D%22quickView%22%20style%3D%22margin-bottom%3A0px%22%3E%0D%0A%09%3Ctable%20border%3D0%20cellspacing%3D1%3E%3Ctr%3E%3Ctd%3E%3Cfont%20size%3D+2%3E%0D%0A%09%3Cinput%20type%3D%22text%22%20size%3D5%20id%3D%22classMask%22%20/%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22classMaskChanged%22%20value%3D%22%3E%3E%22%3E%0D%0A%09%3Cselect%20id%3D%22classList%22%20size%3D1%3E%3C/select%3E%0D%0A%09%3C/font%3E%3C/td%3E%3Ctd%3E%3Cfont%20size%3D+2%3E%0D%0A%09%3Cinput%20type%3D%22text%22%20size%3D5%20id%3D%22methodMask%22%20/%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22methodMaskChanged%22%20value%3D%22%3E%3E%22%3E%0D%0A%09%3Cselect%20id%3D%22methodList%22%20size%3D1%3E%0D%0A%09%3C/select%3E%0D%0A%09%3C/font%3E%3C/td%3E%3C/tr%3E%3C/table%3E%0D%0A%3C/form%3E");return self;}

,"views",unescape("quickViewHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20workspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%0D%0A%3Cform%20name%3D%22quickView%22%20style%3D%22margin-bottom%3A0px%22%3E%0D%0A%09%3Ctable%20border%3D0%20cellspacing%3D1%3E%3Ctr%3E%3Ctd%3E%3Cfont%20size%3D+2%3E%0D%0A%09%3Cinput%20type%3D%22text%22%20size%3D5%20id%3D%22classMask%22%20/%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22classMaskChanged%22%20value%3D%22%3E%3E%22%3E%0D%0A%09%3Cselect%20id%3D%22classList%22%20size%3D1%3E%3C/select%3E%0D%0A%09%3C/font%3E%3C/td%3E%3Ctd%3E%3Cfont%20size%3D+2%3E%0D%0A%09%3Cinput%20type%3D%22text%22%20size%3D5%20id%3D%22methodMask%22%20/%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22methodMaskChanged%22%20value%3D%22%3E%3E%22%3E%0D%0A%09%3Cselect%20id%3D%22methodList%22%20size%3D1%3E%0D%0A%09%3C/select%3E%0D%0A%09%3C/font%3E%3C/td%3E%3C/tr%3E%3C/table%3E%0D%0A%3C/form%3E%27"));


smalltalk.bind(smalltalk.S8Web,"transcriptHTML","transcriptHTML"

,function (){var self=this;return unescape("%0D%0A%3Cform%20name%3D%22transcriptForm%22%3E%3Chr%3E%0D%0A%09%3Ctable%20border%3D0%3E%3Ctr%3E%3Ctd%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20value%3D%22Clear%22%20id%3D%22transcriptReset%22%20onClick%3D%22%22%3E%3C/td%3E%3Ctd%3E%0D%0A%09%3Cdiv%20id%3D%22transcriptView%22%3E%5BTranscript%5D%3C/div%3E%0D%0A%09%3C/td%3E%3C/tr%3E%3C/table%3E%0D%0A%3C/form%3E");return self;}

,"views",unescape("transcriptHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20workspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%0D%0A%3Cform%20name%3D%22transcriptForm%22%3E%3Chr%3E%0D%0A%09%3Ctable%20border%3D0%3E%3Ctr%3E%3Ctd%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20value%3D%22Clear%22%20id%3D%22transcriptReset%22%20onClick%3D%22%22%3E%3C/td%3E%3Ctd%3E%0D%0A%09%3Cdiv%20id%3D%22transcriptView%22%3E%5BTranscript%5D%3C/div%3E%0D%0A%09%3C/td%3E%3C/tr%3E%3C/table%3E%0D%0A%3C/form%3E%27"));


smalltalk.bind(smalltalk.S8Web,"portrait","portrait"

,function (){var self=this;return smalltalk.DOM.screen().width()._lt(smalltalk.DOM.screen().height());return self;}

,"orientation",unescape("portrait%0D%0A%09%22%20Private%20-%20Return%20true%20if%20the%20layout%20of%20the%20receiver%20is%20%23portrait.%20%22%0D%0A%0D%0A%09%5EDOM%20screen%20width%20%3C%20DOM%20screen%20height"));


smalltalk.bind(smalltalk.S8Web,"workspaceCodeHTML","workspaceCodeHTML"

,function (){var self=this;return unescape("%3Ctextarea%20id%3D%22code%22%20rows%3D15%20cols%3D67%3E")._comma(self.$klass.initialCodeContents())._comma(unescape("%3C/textArea%3E"));return self;}

,"views",unescape("workspaceCodeHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20%28workspace%29code%20pane%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%3Ctextarea%20id%3D%22code%22%20rows%3D15%20cols%3D67%3E%27%20%2Cself%20class%20initialCodeContents%20%2C%27%3C/textArea%3E%27"));


smalltalk.bind(smalltalk.S8Web,"workspaceResultHTML","workspaceResultHTML"

,function (){var self=this;return unescape("%3Ctextarea%20id%3D%22result%22%20rows%3D15%20cols%3D60%3E%20%3C/textarea%3E");return self;}

,"views",unescape("workspaceResultHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20%28workspace%29result%20pane%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%3Ctextarea%20id%3D%22result%22%20rows%3D15%20cols%3D60%3E%20%3C/textarea%3E%27"));


smalltalk.bind(smalltalk.S8Web,"workspaceActionsHTML","workspaceActionsHTML"

,function (){var self=this;return unescape("%3Cfont%20size%3D+2%3E%3Cb%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22showIt%22%20value%3D%22showIt%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22fileItIn%22%20value%3D%22fileIn%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22evalIt%22%20value%3D%22javascript%22%3E%0D%0A%09%5B")._comma(self.notesHTML())._comma(unescape("%5D%0D%0A%09%3Cselect%20id%3D%22frequentSelector%22%20size%3D%221%22%3E%3C/select%3E%0D%0A%09%3C/b%3E%3C/font%3E"));return self;}

,"views",unescape("workspaceActionsHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20%28workspace%29actions%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%3Cfont%20size%3D+2%3E%3Cb%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22showIt%22%20value%3D%22showIt%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22fileItIn%22%20value%3D%22fileIn%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22evalIt%22%20value%3D%22javascript%22%3E%0D%0A%09%5B%27%2Cself%20notesHTML%2C%27%5D%0D%0A%09%3Cselect%20id%3D%22frequentSelector%22%20size%3D%221%22%3E%3C/select%3E%0D%0A%09%3C/b%3E%3C/font%3E%27"));


smalltalk.bind(smalltalk.S8Web,"notesHTML","notesHTML"

,function (){var self=this;return unescape("%3Cinput%20type%3D%22button%22%20id%3D%22prevNote%22%20value%3D%22%3C%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22addNote%22%20value%3D%22+%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22removeNote%22%20value%3D%22-%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22nextNote%22%20value%3D%22%3E%22%3E");return self;}

,"views",unescape("notesHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20%28note%29actions%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%3Cinput%20type%3D%22button%22%20id%3D%22prevNote%22%20value%3D%22%3C%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22addNote%22%20value%3D%22+%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22removeNote%22%20value%3D%22-%22%3E%0D%0A%09%3Cinput%20type%3D%22button%22%20id%3D%22nextNote%22%20value%3D%22%3E%22%3E%27"));


smalltalk.bind(smalltalk.S8Web,"workspaceRowsHTML","workspaceRowsHTML"

,function (){var self=this;var separator=nil;var colspan=nil;separator=colspan="";

((self.portrait()).mustBeBoolean()==true ? (function(){return separator=unescape("%3C/tr%3E%3Ctr%3E");})() : (function(){return colspan=unescape("%20colspan%3D2");})());

return unescape("%3Ctr%3E%3Ctd%3E")._comma(self.workspaceCodeHTML())._comma(unescape("%3C/td%3E"))._comma(separator)._comma(unescape("%3Ctd%3E"))._comma(self.workspaceResultHTML())._comma(unescape("%3C/td%3E%3Ctr"))._comma(colspan)._comma(unescape("%3E%3Ctd%3E"))._comma(self.workspaceActionsHTML())._comma(unescape("%3C/td%3E%3C/tr%3E"));return self;}

,"views",unescape("workspaceRowsHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20%28workspace%29rows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20separator%20colspan%20%7C%0D%0A%09separator%20%3A%3D%20colspan%20%3A%3D%20%27%27.%0D%0A%09self%20portrait%20ifTrue%3A%20%5B%0D%0A%09%09separator%20%3A%3D%20%27%3C/tr%3E%3Ctr%3E%27.%0D%0A%09%5D%20ifFalse%3A%20%5B%0D%0A%09%09colspan%20%20%20%3A%3D%20%27%20colspan%3D2%27.%0D%0A%09%5D.%0D%0A%0D%0A%09%5E%27%3Ctr%3E%3Ctd%3E%27%2C%09self%20workspaceCodeHTML%0D%0A%09%2C%27%3C/td%3E%27%2C%09separator%0D%0A%09%2C%27%3Ctd%3E%27%2C%09self%20workspaceResultHTML%0D%0A%09%2C%27%3C/td%3E%3Ctr%27%2C%09colspan%0D%0A%09%2C%27%3E%3Ctd%3E%27%2C%09self%20workspaceActionsHTML%0D%0A%09%2C%27%3C/td%3E%3C/tr%3E%27"));


smalltalk.bind(smalltalk.S8Web,"workspaceHTML","workspaceHTML"

,function (){var self=this;return unescape("%3Cform%3E%3Ctable%20border%3D0%3E%0D%0A%09")._comma(self.workspaceRowsHTML())._comma(unescape("%0D%0A%09%3C/table%3E%3C/form%3E"));return self;}

,"views",unescape("workspaceHTML%0D%0A%09%22%20Private%20-%20Return%20the%20HTML%20code%20for%20workspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27%3Cform%3E%3Ctable%20border%3D0%3E%0D%0A%09%27%2Cself%20workspaceRowsHTML%2C%27%0D%0A%09%3C/table%3E%3C/form%3E%27"));


smalltalk.bind(smalltalk.S8Web,"maximizePlayground","maximizePlayground"

,function (){var self=this;(function($rec){$rec.left_((0));$rec.top_((0));$rec.width_(unescape("100%25"));return $rec.height_(unescape("100%25"));})(self.playground().style());

self.hideAllExcept_("playground");return self;}

,"GUI",unescape("maximizePlayground%0D%0A%09%22%20Private%20-%20Maximize%20the%20playground.%20%22%0D%0A%0D%0A%09self%20playground%20style%0D%0A%09%09left%3A%200%3B%20top%3A%200%3B%0D%0A%09%09width%3A%20%27100%25%27%3B%20height%3A%20%27100%25%27.%0D%0A%09self%20hideAllExcept%3A%20%23playground."));


smalltalk.bind(smalltalk.S8Web,"hideAllExcept:","hideAllExcept_"

,function (anId){var self=this;smalltalk.DOM.document().body().childNodes().do_((function(each){return ((((each.id() || nil) === nil).or_((function(){return each.id()._eq(anId);}))).mustBeBoolean()==true ? nil : (function(){return ((((each.style() || nil) !== nil)).mustBeBoolean()==true ? (function(){return each.style().display_("none");})() : nil);})());}));return self;}

,"GUI",unescape("hideAllExcept%3A%20anId%0D%0A%09%22%20Maximize%20the%20elements%20in%20current%20document%20except%20the%20element%20with%20id%20anId.%20%22%0D%0A%0D%0A%09DOM%20document%20body%20childNodes%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09%28each%20id%20isNil%20or%3A%20%5B%20each%20id%20%3D%20anId%20%5D%29%20ifFalse%3A%20%5B%0D%0A%09%09%09each%20style%20notNil%20ifTrue%3A%20%5B%20each%20style%20display%3A%20%23none%20%5D%0D%0A%09%09%5D.%0D%0A%09%5D"));


smalltalk.bind(smalltalk.S8Web,"restorePlayground","restorePlayground"

,function (){var self=this;(function($rec){$rec.width_(unescape("100%25"));return $rec.height_("20px");})(self.playground().style());

self.playground().innerHTML_(unescape("-playground-"));return self;}

,"GUI",unescape("restorePlayground%0D%0A%09%22%20Private%20-%20Restore%20the%20playground%20to%20the%20original%20size%20and%20content.%20%22%0D%0A%0D%0A%09self%20playground%20style%20width%3A%20%27100%25%27%3B%20height%3A%20%2720px%27.%0D%0A%09self%20playground%20innerHTML%3A%20%27-playground-%27"));


smalltalk.bind(smalltalk.S8Web,"restoreAll","restoreAll"

,function (){var self=this;smalltalk.DOM.document().body().childNodes().do_((function(each){return ((((each.style() || nil) !== nil)).mustBeBoolean()==true ? (function(){return each.style().display_("block");})() : nil);}));

self.restorePlayground();return self;}

,"GUI",unescape("restoreAll%0D%0A%09%22%20Restore%20the%20elements%20in%20current%20document.%20%22%0D%0A%0D%0A%09DOM%20document%20body%20childNodes%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09each%20style%20notNil%20ifTrue%3A%20%5B%20each%20style%20display%3A%20%23block%20%5D%0D%0A%09%5D.%0D%0A%09self%20restorePlayground."));


smalltalk.bind(smalltalk.S8Web,"codeValue","codeValue"

,function (){var self=this;return self._at("code").value();return self;}

,"accessing",unescape("codeValue%0D%0A%09%22%20Return%20the%20value%20in%20the%20code%20pane.%20%22%0D%0A%0D%0A%09%5E%28self%20@%20%23code%29%20value"));


smalltalk.bind(smalltalk.S8Web,"codeValue:","codeValue_"

,function (aValue){var self=this;return self._at("code").value_(aValue);return self;}

,"accessing",unescape("codeValue%3A%20aValue%0D%0A%09%22%20Set%20the%20value%20in%20the%20code%20pane.%20%22%0D%0A%0D%0A%09%5E%28self%20@%20%23code%29%20value%3A%20aValue"));


smalltalk.bind(smalltalk.S8Web,"resultValue","resultValue"

,function (){var self=this;return self._at("result").value();return self;}

,"accessing",unescape("resultValue%0D%0A%09%22%20Return%20the%20value%20in%20the%20result%20pane.%20%22%0D%0A%0D%0A%09%5E%28self%20@%20%23result%29%20value"));


smalltalk.bind(smalltalk.S8Web,"resultValue:","resultValue_"

,function (aValue){var self=this;return self._at("result").value_(aValue);return self;}

,"accessing",unescape("resultValue%3A%20aValue%0D%0A%09%22%20Set%20the%20value%20in%20the%20result%20pane.%20%22%0D%0A%0D%0A%09%5E%28self%20@%20%23result%29%20value%3A%20aValue"));


smalltalk.bind(smalltalk.S8Web,"onLoadActions","onLoadActions"

,function (){var self=this;return self.$klass.onLoadActions();return self;}

,"accessing",unescape("onLoadActions%0D%0A%09%22%20Return%20the%20actions%20to%20evaluate%20on%20load.%20%22%0D%0A%0D%0A%09%5Eself%20class%20onLoadActions"));


smalltalk.bind(smalltalk.S8Web,"sample","sample"

,function (){var self=this;try{var document=nil;var sample=nil;var first=nil;document=smalltalk.DOM.document();

sample=document._at("sample");

((((sample || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "sample", fn: function(){return sample}})})();})() : nil);

sample=document.createElement_("div");

sample.id_("sample");

first=document.body().childNodeAt_((1));

document.body().insert_before_(sample.handle(), first.handle());

(function(){throw({name: "stReturn", selector: "sample", fn: function(){return sample}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "sample"){return $$ex.fn();} throw($$ex);}}

,"accessing",unescape("sample%0D%0A%09%22%20Return%20the%20sample%20DIV%20element.%0D%0A%09If%20the%20element%20is%20not%20still%20present%20in%20the%20page%2C%20it%20will%20be%20created.%0D%0A%09%22%0D%0A%09%7C%20document%20sample%20first%20%7C%0D%0A%09document%20%3A%3D%20DOM%20document.%0D%0A%09sample%20%3A%3D%20document%20@%20%23sample.%0D%0A%09sample%20notNil%20ifTrue%3A%20%5B%20%5Esample%20%5D.%0D%0A%09sample%20%3A%3D%20document%20createElement%3A%20%23div.%0D%0A%09sample%20id%3A%20%23sample.%0D%0A%09first%20%3A%3D%20document%20body%20childNodeAt%3A%201.%0D%0A%09document%20body%20insert%3A%20sample%20handle%20before%3A%20first%20handle.%0D%0A%09%5Esample%20"));


smalltalk.bind(smalltalk.S8Web,"notes","notes"

,function (){var self=this;return smalltalk.Smalltalk.at_ifAbsentPut_("WorkspaceAnnotations", (function(){return smalltalk.Array.$$new();}));return self;}

,"accessing",unescape("notes%0D%0A%09%22%20Return%20the%20notes%20stored%20in%20the%20annotation%20system.%20%22%0D%0A%0D%0A%09%5ESmalltalk%20at%3A%20%23WorkspaceAnnotations%20ifAbsentPut%3A%20%5B%20Array%20new%20%5D"));


smalltalk.bind(smalltalk.S8Web,"hasNotes","hasNotes"

,function (){var self=this;return smalltalk.Smalltalk.at_ifAbsent_("WorkspaceAnnotations", (function(){return [];})).notEmpty();return self;}

,"accessing",unescape("hasNotes%0D%0A%09%22%20Return%20true%20if%20there%20is%20at%20least%20one%20annotation%20saved.%20%22%0D%0A%0D%0A%09%5E%28Smalltalk%20at%3A%20%23WorkspaceAnnotations%20ifAbsent%3A%20%5B%20%23%28%29%20%5D%29%20notEmpty"));


smalltalk.bind(smalltalk.S8Web,"prevNote","prevNote"

,function (){var self=this;try{var note=nil;var index=nil;((self.hasNotes()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "prevNote", fn: function(){return self.print_("There is no annotations.")}})})();})());

note=self.codeValue();

index=self.notes().indexOf_ifAbsent_(note, (function(){return (0);}));

index=(index - (1));

(((index <= (0))).mustBeBoolean()==true ? (function(){return index=self.notes().size();})() : nil);

self.codeValue_(self.notes().at_ifAbsent_(index, (function(){return note;})));

self.print_(unescape("Annotation%20%23")._comma(index.asString()));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "prevNote"){return $$ex.fn();} throw($$ex);}}

,"notes",unescape("prevNote%0D%0A%09%22%20Fill%20contents%20of%20code%20pane%20with%20previous%20note.%20%22%0D%0A%0D%0A%09%7C%20note%20index%20%7C%0D%0A%09self%20hasNotes%20ifFalse%3A%20%5B%20%5Eself%20print%3A%20%27There%20is%20no%20annotations.%27%20%5D.%0D%0A%09note%20%3A%3D%20self%20codeValue.%0D%0A%09index%20%3A%3D%20self%20notes%20indexOf%3A%20note%20ifAbsent%3A%20%5B%200%20%5D.%0D%0A%09index%20%3A%3D%20index%20-%201.%0D%0A%09index%20%3C%3D%200%20ifTrue%3A%20%5B%20index%20%3A%3D%20self%20notes%20size%20%5D.%0D%0A%09self%20codeValue%3A%20%28self%20notes%20at%3A%20index%20ifAbsent%3A%20%5B%20note%20%5D%29.%0D%0A%09self%20print%3A%20%27Annotation%20%23%27%2Cindex%20asString."));


smalltalk.bind(smalltalk.S8Web,"nextNote","nextNote"

,function (){var self=this;try{var note=nil;var index=nil;((self.hasNotes()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "nextNote", fn: function(){return self.print_("There is no annotations.")}})})();})());

note=self.codeValue();

index=self.notes().indexOf_ifAbsent_(note, (function(){return self.notes().size();}));

index=(index + (1));

((index._gt(self.notes().size())).mustBeBoolean()==true ? (function(){return index=(1);})() : nil);

self.codeValue_(self.notes().at_ifAbsent_(index, (function(){return note;})));

self.print_(unescape("Annotation%20%23")._comma(index.asString()));return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "nextNote"){return $$ex.fn();} throw($$ex);}}

,"notes",unescape("nextNote%0D%0A%09%22%20Fill%20contents%20of%20code%20pane%20with%20next%20note.%20%22%0D%0A%0D%0A%09%7C%20note%20index%20%7C%0D%0A%09self%20hasNotes%20ifFalse%3A%20%5B%20%5Eself%20print%3A%20%27There%20is%20no%20annotations.%27%20%5D.%0D%0A%09note%20%3A%3D%20self%20codeValue.%0D%0A%09index%20%3A%3D%20self%20notes%20indexOf%3A%20note%20ifAbsent%3A%20%5B%20self%20notes%20size%20%5D.%0D%0A%09index%20%3A%3D%20index%20+%201.%0D%0A%09index%20%3E%20self%20notes%20size%20ifTrue%3A%20%5B%20index%20%3A%3D%201%20%5D.%0D%0A%09self%20codeValue%3A%20%28self%20notes%20at%3A%20index%20ifAbsent%3A%20%5B%20note%20%5D%29.%0D%0A%09self%20print%3A%20%27Annotation%20%23%27%2Cindex%20asString."));


smalltalk.bind(smalltalk.S8Web,"addNote","addNote"

,function (){var self=this;self.notes().add_(self.codeValue());

self.print_(unescape("Annotation%20%23")._comma(self.notes().size().asString())._comma(" saved."));return self;}

,"notes",unescape("addNote%0D%0A%09%22%20Add%20the%20contents%20of%20code%20pane%20as%20a%20new%20note.%20%22%0D%0A%0D%0A%09self%20notes%20add%3A%20self%20codeValue.%0D%0A%09self%20print%3A%20%27Annotation%20%23%27%2Cself%20notes%20size%20asString%2C%27%20saved.%27"));


smalltalk.bind(smalltalk.S8Web,"removeNote","removeNote"

,function (){var self=this;try{((self.hasNotes()).mustBeBoolean()==true ? nil : (function(){return (function(){throw({name: "stReturn", selector: "removeNote", fn: function(){return self.print_("There is no annotations.")}})})();})());

self.notes().remove_ifAbsent_(self.codeValue(), (function(){return (function(){throw({name: "stReturn", selector: "removeNote", fn: function(){return self.print_("There is no annotation with this text.")}})})();}));

self.print_("Annotation removed.");return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "removeNote"){return $$ex.fn();} throw($$ex);}}

,"notes",unescape("removeNote%0D%0A%09%22%20Remove%20the%20current%20contents%20of%20code%20pane%20from%20Annoation%20sytem.%20%22%0D%0A%0D%0A%09self%20hasNotes%20ifFalse%3A%20%5B%20%5Eself%20print%3A%20%27There%20is%20no%20annotations.%27%20%5D.%0D%0A%09self%20notes%0D%0A%09%09remove%3A%20self%20codeValue%0D%0A%09%09ifAbsent%3A%20%5B%20%5Eself%20print%3A%20%27There%20is%20no%20annotation%20with%20this%20text.%27%20%5D.%0D%0A%09self%20print%3A%20%27Annotation%20removed.%27"));


smalltalk.bind(smalltalk.S8Web,"require:","require_"

,function (requirement){var self=this;return self.require_useNative_(requirement, true);return self;}

,"require",unescape("require%3A%20requirement%0D%0A%09%5Eself%20require%3A%20requirement%20useNative%3A%20true"));


smalltalk.bind(smalltalk.S8Web,"require:useNative:","require_useNative_"

,function (requirement,useNative){var self=this;try{var $$native=nil;var url=nil;((requirement.isArray()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return requirement.collect_((function(each){return self.require_useNative_(each, useNative);}))}})})();})() : nil);

((useNative).mustBeBoolean()==true ? (function(){$$native=smalltalk.Smalltalk.jsObjectAt_ifAbsent_("require", (function(){return nil;}));(((($$native || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return $$native.value_(requirement)}})})();})() : nil);return (function(what){return self.require_useNative_(what, false);}).installAs_("require");})() : nil);

((((requirement || nil) === nil)).mustBeBoolean()==true ? (function(){self['@requireMap']=nil;return (function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return nil}})})();})() : nil);

url=self.resolve_(requirement);

((((url || nil) === nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return nil}})})();})() : nil);

((url.isArray()).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return self.require_useNative_(url, useNative)}})})();})() : nil);

((((self['@requireMap'] || nil) === nil)).mustBeBoolean()==true ? (function(){return self['@requireMap']=smalltalk.Dictionary.$$new();})() : nil);

(function(){throw({name: "stReturn", selector: "require_useNative_", fn: function(){return self['@requireMap'].at_ifAbsentPut_(url, (function(){return self.loadScript_(url);}))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "require_useNative_"){return $$ex.fn();} throw($$ex);}}

,"require",unescape("require%3A%20requirement%20useNative%3A%20useNative%0D%0A%09%22%20Return%20the%20required%20object%20obtained%20from%20loading%20requirement.%0D%0A%09-%20requirement%20can%20be%20anArray%20of%20requirements%0D%0A%09-%20the%20native/global%20function%20require%28%29%20can%20be%20used%20if%20present%20in%20globals%0D%0A%09-%20if%20requirement%20isNil%2C%20the%20internal%20cache%20is%20reset.%0D%0A%09-%20see%20%23resolve%3A%20to%20understand%20name%20resolution%0D%0A%09--%20return%20nil%20if%20name%20can%uFFFDt%20be%20resolved%0D%0A%09--%20if%20resolution%20return%20an%20array%2C%20it%20will%20load%20multiple%20requirements%0D%0A%09-%20see%20%23basicRequire%3A%20to%20understand%20loading%20mechanism%0D%0A%09%22%0D%0A%0D%0A%09%7C%20native%20url%20%7C%0D%0A%09requirement%20isArray%20ifTrue%3A%20%5B%0D%0A%09%09%5Erequirement%20collect%3A%20%5B%3Aeach%7C%20self%20require%3A%20each%20useNative%3A%20useNative%20%5D%0D%0A%09%5D.%0D%0A%09useNative%20ifTrue%3A%20%5B%0D%0A%09%09native%20%3A%3D%20Smalltalk%20jsObjectAt%3A%20%23require%20ifAbsent%3A%20%5B%5D.%0D%0A%09%09native%20notNil%20ifTrue%3A%20%5B%20%5Enative%20value%3A%20requirement%20%5D.%0D%0A%09%09%5B%3Awhat%7C%20self%20require%3A%20what%20useNative%3A%20false%20%5D%20installAs%3A%20%23require.%0D%0A%09%5D.%0D%0A%09requirement%20isNil%20ifTrue%3A%20%5B%20requireMap%20%3A%3D%20nil.%20%5Enil%20%5D.%0D%0A%09url%20%3A%3D%20self%20resolve%3A%20requirement.%0D%0A%09url%20isNil%20ifTrue%3A%20%5B%20%5Enil%20%5D.%0D%0A%09url%20isArray%20ifTrue%3A%20%5B%20%5Eself%20require%3A%20url%20useNative%3A%20useNative%20%5D.%0D%0A%09requireMap%20isNil%20ifTrue%3A%20%5B%20requireMap%20%3A%3D%20Dictionary%20new%20%5D.%0D%0A%09%5ErequireMap%20at%3A%20url%20ifAbsentPut%3A%20%5B%20self%20loadScript%3A%20url%20%5D"));


smalltalk.bind(smalltalk.S8Web,"requireSolver:","requireSolver_"

,function (aBlock){var self=this;self['@requireSolver']=aBlock;return self;}

,"require",unescape("requireSolver%3A%20aBlock%0D%0A%09%22%20Set%20the%20solver%20used%20to%20find%20url%20of%20requirements.%20%22%0D%0A%0D%0A%09requireSolver%20%3A%3D%20aBlock"));


smalltalk.bind(smalltalk.S8Web,"resolve:","resolve_"

,function (codeName){var self=this;try{var result=nil;var fileName=nil;(("u8"._eq(codeName.upTo_(":"))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "resolve_", fn: function(){return self.resolve_(self.profileURL()._comma(codeName.copyFrom_to_((4), codeName.size())))}})})();})() : nil);

((((self['@requireSolver'] || nil) !== nil)).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "resolve_", fn: function(){return self['@requireSolver'].value_(codeName)}})})();})() : nil);

((codeName.first()._eq(".")).mustBeBoolean()==true ? (function(){((codeName.second()._eq(unescape("/"))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "resolve_", fn: function(){return self.resolve_(requireFolder._comma(codeName.copyFrom_to_((3), codeName.size())))}})})();})() : nil);return ((codeName.third()._eq(".").and_((function(){return codeName.fourth()._eq(unescape("/"));}))).mustBeBoolean()==true ? (function(){return (function(){throw({name: "stReturn", selector: "resolve_", fn: function(){return self.resolve_(self.$klass.parentURL_(requireFolder)._comma(codeName.copyFrom_to_((4), codeName.size())))}})})();})() : nil);})() : nil);

fileName=codeName.copyFrom_to_((codeName.lastIndexOf_(unescape("/")) + (1)), codeName.size());

(function(){throw({name: "stReturn", selector: "resolve_", fn: function(){return ((fileName.includes_(".")).mustBeBoolean()==true ? (function(){return codeName;})() : (function(){return codeName._comma(".js");})())}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "resolve_"){return $$ex.fn();} throw($$ex);}}

,"require",unescape("resolve%3A%20codeName%0D%0A%09%22%20Private%20-%20Try%20to%20resolve%20the%20codeName%20to%20return%20url%20of%20source%28s%29%20to%20load.%0D%0A%09Return%20nil%20on%20failure%2C%20an%20URL%20or%20anArray%20of%20codeNames%20to%20require%20%28recursivelly%29.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20result%20fileName%20%7C%0D%0A%09%23u8%20%3D%20%28codeName%20upTo%3A%20%24%3A%29%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20resolve%3A%20self%20profileURL%2C%20%28codeName%20copyFrom%3A%204%20to%3A%20codeName%20size%29%0D%0A%09%5D.%0D%0A%09requireSolver%20notNil%20ifTrue%3A%20%5B%20%5ErequireSolver%20value%3A%20codeName%20%5D.%0D%0A%09codeName%20first%20%3D%20%24.%20ifTrue%3A%20%5B%0D%0A%09%09codeName%20second%20%3D%20%24/%20ifTrue%3A%20%5B%0D%0A%09%09%09%5Eself%20resolve%3A%20requireFolder%20%2C%28codeName%20copyFrom%3A%203%20to%3A%20codeName%20size%29%0D%0A%09%09%5D.%0D%0A%09%09%28codeName%20third%20%3D%20%24.%20and%3A%20%5B%20codeName%20fourth%20%3D%20%24/%20%5D%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%5Eself%20resolve%3A%20%28self%20class%20parentURL%3A%20requireFolder%29%20%2C%28codeName%20copyFrom%3A%204%20to%3A%20codeName%20size%29%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09fileName%20%3A%3D%20codeName%20copyFrom%3A%20%28codeName%20lastIndexOf%3A%20%24/%29%20+%201%20to%3A%20codeName%20size.%0D%0A%09%5E%28fileName%20includes%3A%20%24.%29%0D%0A%09%09ifTrue%3A%20%5B%20codeName%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20codeName%20%2C%27.js%27%20%5D"));


smalltalk.bind(smalltalk.S8Web,"loadScript:","loadScript_"

,function (url){var self=this;try{self.withContentsOf_do_(url, (function(contents){var old=nil;var result=nil;old=requireFolder;requireFolder=url.upToLast_(unescape("/"));(function(){return result=eval(unescape("function%28%29%20%7B%20var%20exports%20%3D%20%7B%7D%3B")._comma(contents)._comma(unescape("%20return%20exports%3B%7D%28%29%3B")));}).ensure_((function(){return requireFolder=old;}));return (function(){throw({name: "stReturn", selector: "loadScript_", fn: function(){return result}})})();}));

(function(){throw({name: "stReturn", selector: "loadScript_", fn: function(){return self.error_("Accessing code at "._comma(url))}})})();return self;} catch($$ex) {if($$ex.name === "stReturn" && $$ex.selector === "loadScript_"){return $$ex.fn();} throw($$ex);}}

,"require",unescape("loadScript%3A%20url%0D%0A%09%22%20Private%20-%20Load%20the%20%28require%20formated%29%20code%20script%20at%20url.%0D%0A%09Return%20the%20requirement%20result%20%28a%20hash%20object%29.%0D%0A%09Can%20trigger%20errors%20during%20loading...%0D%0A%09%22%0D%0A%0D%0A%09self%20withContentsOf%3A%20url%20do%3A%20%5B%3Acontents%7C%20%7C%20old%20result%20%7C%0D%0A%09%09old%20%3A%3D%20requireFolder.%0D%0A%09%09requireFolder%20%3A%3D%20url%20upToLast%3A%20%24/.%0D%0A%09%09%5B%20result%20%3A%3D%20%23%20%23eval%3A%20%28%0D%0A%09%09%09%27function%28%29%20%7B%20var%20exports%20%3D%20%7B%7D%3B%27%0D%0A%09%09%09%2Ccontents%0D%0A%09%09%09%2C%27%20return%20exports%3B%7D%28%29%3B%27%29.%0D%0A%09%09%5D%20ensure%3A%20%5B%20requireFolder%20%3A%3D%20old%20%5D.%0D%0A%09%09%5Eresult%0D%0A%09%5D.%0D%0A%09%5Eself%20error%3A%20%27Accessing%20code%20at%20%27%20%2Curl"));

